import java.util.HashMap;
import java.util.Map;

public class BMSearch {
        
    public static void main(String[] args) {
        String text    = new String("webwepdbwebdbwwebdbwebbb");
        String pattern = new String("webdb");
        Map<Character, Integer> skipTable = buildSkipTable(pattern);
        int cnt = search(text, pattern, skipTable);
        System.out.println("「" + pattern + "」の出現回数:" + cnt);
    }
        
    private static Map<Character, Integer> buildSkipTable (String pattern) {
        Map<Character, Integer> skip = new HashMap<Character, Integer>();
        int plen = pattern.length();
        for (int i=0;i<plen-1;++i) {
            skip.put(pattern.charAt(i), plen - i - 1);
        }
        return skip;
    }
        
    private static int search(String text, String pattern, Map<Character, Integer> skipTable) {
        int i, tlen, plen, appear_cnt;
        Boolean mismatch;
        i          = 0;
        tlen       = text.length();
        plen       = pattern.length();
        appear_cnt = 0;
        mismatch   = false;
        while (i + plen < tlen) {
            for (int j=plen-1;j>=0;--j) {
                if (text.charAt(i + j) != pattern.charAt(j)) {
                    if (!skipTable.containsKey(text.charAt(i + j))) {
                        if (j == plen - 1) {
                            i += plen;
                        } else {
                            i += plen - j - 1;
                        }
                    } else {
                        int s = skipTable.get(text.charAt(i + j)) - (plen - 1 - j);
                        if (s <= 0) { // 照合開始位置が前に戻ってしまうので、1文字だけずらす
                            ++i;
                        } else {
                            i += s;
                        }
                    }
                    mismatch = true;
                    break;
                }
            }

            // 照合失敗
            if (mismatch) {
                mismatch = false;
                continue;
            }

            // 照合成功
            if (!skipTable.containsKey(text.charAt(i + plen - 1))) {
                i += plen;
            } else {
                i += skipTable.get(text.charAt(i + plen - 1));
            }

            ++appear_cnt;
        }
        return appear_cnt;              
    }

}
